<script>
// import { ValidationObserver } from 'vee-validate'
// import {
//   BAlert,
//   BButton,
//   BCol,
//   BForm,
//   BFormGroup,
//   BFormInput,
//   BFormTextarea,
//   BRow,
//   BSpinner,
// } from 'bootstrap-vue'
// import { email, required } from '@validations'
import UserApiV1 from '@/api/userApi'

export default {
  name: 'EditUserForm',
  components: {
    ValidationObserver,
    BAlert,
    BForm,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BButton,
    BSpinner,
    BFormTextarea,
  },
  props: {
    ldapData: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      user: { username: '', rol: '' },
      optionsRol: [
        { value: null, text: 'Please select some item' },
        { value: 'USER', text: 'Operator' },
        { value: 'DEVELOPER', text: 'Developer' },
        { value: 'ADMIN', text: 'Administrator' },
      ],
      required,
      email,
      saving: false,
      isRequest: false,
      isError: false,
      requestMessage: '',
    }
  },
  computed: {
    alertToggleVariant() {
      return this.isError ? 'danger' : 'success'
    },
    alertToggleText() {
      return this.isError ? 'Error!' : 'Success!'
    },
    prepareOptionsRol() {
      const options = this.optionsRol
      if (this.user.rol.toLowerCase() === 'root')
        options.push({ value: 'ROOT', text: 'root' })

      return options
    },
  },
  mounted() {
    this.user = this.$store.state.user
  },
  methods: {
    async saveUser() {
      this.saving = true
      console.log('this.ldapData: ', this.ldapData)

      const users = new UserApiV1()
      try {
        this.responseldapData = await users.updateUser(this.ldapData)
        console.log('responseldapData: ', JSON.parse(JSON.stringify(this.responseldapData.data)))
        this.requestMessage = this.responseldapData.data.message
        this.isError = false
      }
      catch (error) {
        console.log('error getUserById', error)
        this.requestMessage = error.response.data.message
        this.isError = true
      }
      this.saving = false
      this.isRequest = true
    },
  },
}
</script>

<template>
  <ValidationObserver ref="simpleRules">
    <BForm class="mt-2">
      <BRow>
        <!-- ca_file -->
        <BCol sm="6">
          <BFormGroup
            label="ca_file"
            label-for="ca_file"
          >
            <BFormInput
              v-model="ldapData.ca_file"
              placeholder="/etc/ca.pem"
              name="ca_file"
              required
            />
            <small
              id="caFileHelp"
              class="form-text text-muted"
            >
              The path to your CA certificate file. Example: '/etc/ca.pem'
            </small>
          </BFormGroup>
        </BCol>

        <!-- ssl_version -->
        <BCol sm="6">
          <BFormGroup
            label="ssl_version"
            label-for="ssl_version"
          >
            <BFormInput
              v-model="ldapData.ssl_version"
              placeholder="TLSv1_1"
              name="ssl_version"
              required
            />
            <small
              id="sslVersionHelp"
              class="form-text text-muted"
            >
              The SSL/TLS protocol version to use. Example: 'TLSv1_1'
            </small>
          </BFormGroup>
        </BCol>

        <!-- ciphers -->
        <BCol sm="6">
          <BFormGroup
            label="ciphers"
            label-for="ciphers"
          >
            <BFormInput
              v-model="ldapData.ciphers"
              placeholder="ALL:!EXPORT:!LOW:!aNULL:!eNULL:!SSLv2"
              name="ciphers"
              required
            />
            <small
              id="ciphersHelp"
              class="form-text text-muted"
            >
              The list of allowed ciphers for SSL/TLS connections. Example: 'ALL:!EXPORT:!LOW:!aNULL:!eNULL:!SSLv2'
            </small>
          </BFormGroup>
        </BCol>

        <!-- cert -->
        <BCol sm="6">
          <BFormGroup
            label="cert"
            label-for="cert"
          >
            <BFormTextarea
              v-model="ldapData.cert"
              placeholder="-----BEGIN CERTIFICATE----- ... -----END CERTIFICATE -----"
              name="cert"
              required
            />

            <small
              id="certHelp"
              class="form-text text-muted"
            >
              The SSL certificate for your LDAP server. Example:
              '-----BEGIN CERTIFICATE----- ... -----END CERTIFICATE -----'
            </small>
          </BFormGroup>
        </BCol>

        <!-- key -->
        <BCol sm="6">
          <BFormGroup
            label="key"
            label-for="key"
          >
            <BFormTextarea
              v-model="ldapData.key"
              placeholder="-----BEGIN PRIVATE KEY----- ... -----END PRIVATE KEY -----"
              name="key"
              required
            />

            <small
              id="keyHelp"
              class="form-text text-muted"
            >
              The private key for your LDAP server's SSL certificate.
              Example: '-----BEGIN PRIVATE KEY----- ... -----END PRIVATE KEY -----'
            </small>
          </BFormGroup>
        </BCol>

        <BCol md="12">
          <BAlert
            v-if="isRequest"
            :variant="alertToggleVariant"
            show
          >
            <div class="alert-body">
              <FeatherIcon
                icon="InfoIcon"
                class="mr-50"
              />
              <span><strong>{{ alertToggleText }}</strong> {{ requestMessage }}.</span>
            </div>
          </BAlert>
        </BCol>
        <BCol cols="12">
          <BButton
            variant="primary"
            class="mt-2 mr-1"
            :disabled="saving"
            @click="saveUser"
          >
            <BSpinner
              v-if="saving"
              small
            />
            <span v-if="saving"> Saving... </span>
            <span v-else> Save changes </span>
          </BButton>
        </BCol>
      </BRow>
    </BForm>
  </ValidationObserver>
</template>

<style scoped>

</style>
